:-( module( instant_prolog_docs, [
      current_predicate_mfa/3, summary_ending/2,autodoc_toPropercase/2, 
      attempt_head_modes/1,fixda2/4,read_once/5, 
      attempt_head_modes_0/3,autodoc_output_path/2, 
      great_clause/2,ignored_assignment/2, 
      export_file_preds/0,fix_doc_args_for_write/2, 
      export_file_preds/1,export_file_preds/6, 
      export_module_preds/0,list_item_per_line/3, 
      functor_compare/3,notes_to_better_text/2, 
      notes_to_better_text/3,autodoc_magic/1, 
      copy_until_line/2,fixup_doc_args/5,fixda/4, 
      flatten_text/3,helper_name/1, 
      list_file_preds/0,list_file_preds/1, 
      list_file_preds/2,autodoc_stream_pred/3, 
      longer_sumry/2,make_l_summary/3, 
      make_module_name/2,autodoc_module/1, 
      autodoc_stream/3,autodoc_stream_data/7, 
      make_l_summary_lc/3,for_m_make_summary/3, 
      make_summary/3,module_meta_transparent/1, 
      mpred_prolog_only_module/1,prefixed_module/4, 
      mpred_show_doc/1,mpred_show_doc/2, 
      mpred_source_file/2,merge_mode_and_varname/3, 
      no_location/3,portray_clause_pi_LR/2, 
      portray_clause_pi_UD/2,predicate_decl_module/2, 
      autodoc_pred/2,autodoc_file_0s/0, 
      autodoc_file_0/1,autodoc_file_0_0/1, 
      scan_and_list_file_preds/1,name_to_mode/4, 
      mode_to_name/4,some_flocation/3, 
      some_location/3,termw_to_atom/2, 
      mpred_type_module/1,target_module/2, 
      list_item_per_line/4,write_modules/0, 
      baseKB:(sf_known/4),attempt_head_vnames/1, 
      attempt_head_varnames_0/1,helper_name0/1, 
      is_crossfile_module_0/1,make_summary0/3, 
      mpred_source_file_0/2,skip_functor_export_0/1, 
      to_comparable_name_arity/3,to_mfa_0/4])).
:-set_module(class(library)).
:-op(600,xfy,:).
:-meta_predicate fixup_doc_args(4,?,?,*,*).
:-meta_predicate notes_to_better_text(2,*,*).
:-meta_predicate list_item_per_line(0,*,*,*),list_item_per_line(0,?,?).
:-multifile baseKB:(sf_known/4).
:-( module_transparent( ( current_predicate_mfa/3  ,
                          summary_ending/2 , 
                          export_file_preds/0 , 
                          export_file_preds/1 , 
                          export_file_preds/6 , 
                          export_module_preds/0 , 
                          functor_compare/3 , 
                          helper_name/1 , 
                          helper_name0/1 , 
                          is_crossfile_module_0/1 , 
                          list_file_preds/0 , 
                          list_file_preds/1 , 
                          list_file_preds/2 , 
                          longer_sumry/2 , 
                          make_l_summary/3 , 
                          make_module_name/2 , 
                          module_meta_transparent/1 , 
                          mpred_prolog_only_module/1 , 
                          mpred_source_file/2 , 
                          merge_mode_and_varname/3 , 
                          no_location/3 , 
                          portray_clause_pi_LR/2 , 
                          portray_clause_pi_UD/2 , 
                          autodoc_pred/2 , 
                          scan_and_list_file_preds/1 , 
                          skip_functor_export_0/1 , 
                          some_flocation/3 , 
                          some_location/3 , 
                          target_module/2 , 
                          to_comparable_name_arity/3 , 
                          to_mfa_0/4 , 
                          write_modules/0))).
:-( export( ( helper_name0/1  ,
              is_crossfile_module_0/1 , 
              make_summary0/3 , 
              mpred_source_file_0/2 , 
              skip_functor_export_0/1 , 
              to_comparable_name_arity/3 , 
              to_mfa_0/4))).
:-use_module(library(logicmoo_utils)).
:-use_module(library(dictoo)).
make_module_name(P,Module) :- 
  P\==user , 
  module_property(Module,file(P)) , 
  !.
make_module_name(P,P):-current_module(P).
make_module_name(P,O) :- 
  atom(P) , 
  ! , 
  file_base_name(P,F) , 
  file_name_extension(M,_Ext,F) , 
  M\==F->make_module_name(M,O);O=M.
make_module_name(P2/P,M) :- 
  nonvar(P) , 
  ! , 
  make_module_name(P,M).
make_module_name(P,M) :- 
  must(filematch(P,F)) , 
  F\=P , 
  ! , 
  make_module_name(F,M).
helper_name0(F) :- 
  atom_chars(F,Chars) , 
  append(_15844,[U,N],Chars) , 
  char_type(U,digit);char_type(N,digit) , 
  !.
helper_name(_22236:FA):-!,helper_name(FA).
helper_name(F/_25852):-!,helper_name(F).
helper_name(F):-atom(F),helper_name0(F).
list_item_per_line(NL,PerLine,List) :-  
  list_item_per_line(NL,PerLine,PerLine,List).
list_item_per_line(_36522,_36524,_36526,[]).
list_item_per_line(NL,PerLine,NLeft,List) :- 
  NLeft<1 , 
  NL , 
  ! , 
  list_item_per_line(NL,PerLine,PerLine,List).
list_item_per_line(List_item_per_line2,List_item_per_line,PerLine,[E]) :- 
  writeq(E) , 
  !.
list_item_per_line(NL,PerLine,NLeft,[E|List]) :- 
  NNLeft is NLeft-1 , 
  writeq(E) , 
  format(', ') , 
  list_item_per_line(NL,PerLine,NNLeft,List).
portray_clause_pi_LR(_64244,[]):-!.
portray_clause_pi_LR(T,LIST0) :- 
  list_to_set(LIST0,LIST) , 
  length(LIST,Len) , 
  ( Len<8 ->  
      ( list_to_conjuncts(LIST,E)  ,
        P=..[T,E] , 
        format('~N',[]) , 
        portray_clause((:-P))) ; 
    ( format(':- ~w (( ',[T])  ,
      list_item_per_line(format('~N  ',[]),8,LIST) , 
      format('  )).~n'))).
portray_clause_pi_UD(_79168,[]):-!.
portray_clause_pi_UD(T,LIST0) :- 
  list_to_set(LIST0,LIST) , 
  list_to_conjuncts(LIST,E) , 
  format('~N :- ~q % ',[T]) , 
  portray_clause((cmt:-E)) , 
  !.
to_comparable_name_arity(P,_90488,A):-var(P),!,integer(A).
to_comparable_name_arity(FA3-FA,F,A) :- 
  ! , 
  to_comparable_name_arity(FA,F,A).
to_comparable_name_arity(FA3:FA,F,A) :- 
  ! , 
  to_comparable_name_arity(FA,F,A).
to_comparable_name_arity(F/A,F,A) :-  
  !.
to_comparable_name_arity(P,F,A):-functor(P,F,A).
functor_compare(R,_5596-C1,_5602-C2) :- 
  nonvar(C1) , 
  nonvar(C2) , 
  functor_compare(R,C1,C2).
functor_compare(R,M1:P1,M2:P2) :- 
  M1==M2 , 
  ! , 
  functor_compare(R,P1,P2).
functor_compare(R,M1:P1,M2:P2) :- 
  compare(FR,M1,M2) , 
  ! , 
  FR\==(=)->R=FR;functor_compare(R,P1,P2).
functor_compare(R,_23056:_23078,_23100) :-  
  R=>.
functor_compare(R,_28048,_28070:_28092) :-  
  R=<.
functor_compare(R,P1,P2) :- 
  instant_prolog_docs : to_comparable_name_arity(P1,F1,A1) , 
  instant_prolog_docs : to_comparable_name_arity(P2,F2,A2) , 
  ! , 
  compare(FR,F1,F2) , 
  FR\==(=)->R=FR;compare(R,A1,A2).
list_file_preds:-source_location(S,_43476),with_output_doc(list_file_preds(S)).
skip_functor_export_0('$load_context_module'/3).
skip_functor_export_0('$included'/_49190).
skip_functor_export_0('$pldoc'/_51858).
is_crossfile_module_0(baseKB).
is_crossfile_module_0(baseKB).
is_crossfile_module_0(basePFC).
is_crossfile_module_0(user).
to_mfa_0(_65754,user,SM:FA,SM:FA) :-  
  !.
to_mfa_0(To_mfa_0,D69806_Kw,SM:FA,SM:FA) :- 
  is_crossfile_module_0(SM) , 
  !.
to_mfa_0(D64472_PM3,PM,FA2:FA,PM:FA) :- 
  is_crossfile_module_0(PM) , 
  !.
to_mfa_0( FM, 
  PM, 
  SM:(F/A), 
  SM:(F/A)) :- 
  PM=SM , 
  PM=FM , 
  functor(P,F,A) , 
  ( predicate_property(SM:P,thread_local)  ;
    predicate_property(SM:P,multifile) ; 
    predicate_property(SM:P,dynamic)) , 
  !.
to_mfa_0(FM,PM,SM:FA,FA) :- 
  PM=SM , 
  PM=FM , 
  !.
to_mfa_0( FM, 
  PM, 
  SM:(F/A), 
  SM:(F/A)) :- 
  FM==PM , 
  PM\==SM , 
  functor(P,F,A) , 
  predicate_property(SM:P,multifile) , 
  !.
to_mfa_0(FM,PM,SM:FA,FA) :- 
  FM==PM , 
  PM\==SM , 
  !.
to_mfa_0(_53054,_53076,SM:FA,SM:FA) :-  
  !.
scan_and_list_file_preds(F) :-  
  forall( filematch(F,S), 
    ( make_module_name(S,FM)  ,
      ensure_loaded(S) , 
      export_file_preds(S) , 
      list_file_preds(S,FM))).
list_file_preds(F) :-  
  forall( filematch(F,S), 
    ( make_module_name(S,FM)  ,
      ensure_loaded(S) , 
      list_file_preds(S,FM))).
list_file_preds(S,FM) :- 
  must_det_l( ( findall( MP-MFA, 
                  ( mpred_source_file(M:P,S)  ,
                    functor(P,F,A) , 
                    \+skip_functor_export_0(F/A) , 
                    predicate_module(M:P,R) , 
                    to_mfa_0(FM,R,M:(F/A),MFA) , 
                    to_mfa_0(FM,R,M:P,MP)), 
                  List)  ,
                predsort(functor_compare,List,Set) , 
                findall( MFA, 
                  member(MP-MFA,Set),\+helper_name(MFA), 
                  Exports) , 
                findall( MFA, 
                  member(MP-MFA,Set),helper_name(MFA), 
                  Non_Exports) , 
                findall( MFA, 
                  member(MP-MFA,Set),predicate_property(MP,multifile), 
                  Multifile) , 
                format('~N~n~n% File: ~w ~n',[S]) , 
                findall( META, 
                  ( member(MP-MFA,Set) , 
                    predicate_property(MP,(meta_predicate META))), 
                  MPList) , 
                findall( MFA, 
                  member(MP-MFA,Set),predicate_property(MP,transparent), 
                  Transparent) , 
                findall( MFA, 
                  member(MP-MFA,Set),predicate_property(MP,thread_local), 
                  ThreadLocal) , 
                findall( MFA, 
                  ( member(MP-MFA,Set)  ,
                    predicate_property(MP,dynamic) , 
                    \+predicate_property(MP,thread_local)), 
                  Dynamic) , 
                findall( MFA, 
                  member(MP-MFA,Set),predicate_property(MP,volatile), 
                  Volatile) , 
                format('~N:- module(~q, [~n',[FM]) , 
                list_item_per_line(format('~N  ',[]),8,Exports) , 
                list_item_per_line(format('~N    ',[]),20,Non_Exports) , 
                format('  )).~n') , 
                portray_clause_pi_UD(meta_predicate,MPList) , 
                portray_clause_pi_LR(multifile,Multifile) , 
                portray_clause_pi_LR(module_transparent,Transparent) , 
                portray_clause_pi_LR(thread_local,ThreadLocal) , 
                subtract(Dynamic,ThreadLocal,DynamicL) , 
                portray_clause_pi_LR(export,Non_Exports) , 
                portray_clause_pi_LR(dynamic,Dynamic) , 
                portray_clause_pi_LR(kb_shared,DynamicL) , 
                portray_clause_pi_LR(volatile,Volatile))) , 
  !.
:-export(module_meta_transparent/1).
module_meta_transparent(M:(F/A)) :- 
  must(functor(P,F,A)) , 
  ! , 
  module_meta_transparent(M:P).
module_meta_transparent(M:P) :- 
  predicate_property(M:P,(meta_predicate _156594)) , 
  !.
module_meta_transparent(M:P) :- 
  predicate_property(M:P,transparent) , 
  !.
module_meta_transparent(M:P) :- 
  functor(P,F,A) , 
  module_transparent M:(F/A) , 
  !.
 % ground(P), M:meta_predicate(P), !.
% module_meta_transparent(M:P):-P=..[_|Args], must_maplist('='(?), Args), module_meta_transparent(M:P).
module_meta_transparent(_173220).
:-multifile baseKB:(sf_known/4).
:-dynamic baseKB:(sf_known/4).
:-export(mpred_source_file_0/2).
mpred_source_file(M:P,S) :- 
  ! , 
  source_file(M:P,S).
mpred_source_file(M:P,S) :-  
  no_repeats(mpred_source_file_0(M:P,S)).
mpred_source_file_0(M:P,S) :- 
  ! , 
  source_file(M:P,S).
 % , once((to_comparable_name_arity(P, F, A))), nop(autodoc_assert(baseKB:sf_known(S, F, A, M))).
mpred_source_file_0(M:P,S) :- 
  current_module(M) , 
  predicate_property(M:P,file(S)) , 
  \+predicate_property(M:P,imported_from(_201468)).
 % to_comparable_name_arity(P, F, A).
mpred_source_file_0(M:P,S) :-  
  ( var(P) ->  
      baseKB:sf_known(S,F,A,M),functor(P,F,A) ; 
    functor(P,F,A),baseKB:sf_known(S,F,A,M)).
current_predicate_mfa(M,F,A) :- 
  atom(F) , 
  integer(A) , 
  ! , 
  no_repeats( M:(F/A), 
    ( functor(P,F,A)  ,
      current_predicate(D26052_Kw,M:P) , 
      \+predicate_property(M:P,imported_from(M6)))).
current_predicate_mfa(M,F,A) :-  
  no_repeats( M:(F/A), 
    ( current_predicate(D26052_Kw,M:P)  ,
      functor(P,F,A) , 
      \+predicate_property(M:P,imported_from(M6)))).
no_location(M,F,A) :- 
  current_predicate_mfa(M,F,A) , 
  \+baseKB:sf_known(_S,F,A,_MN).
some_location(M,F,A) :-  
  no_repeats( F/A, 
    ( current_predicate_mfa(M,F,A) ; 
      baseKB : sf_known(_S,F,A,_MN))).
some_flocation(FM,F,A) :-  
  no_repeats( F/A, 
    ( baseKB : sf_known(_S,F,A,FM) ; 
      current_predicate_mfa(FM,F,A))).
:-module_transparent export_file_preds/1.
:-export(export_file_preds/0).
export_file_preds:-source_location(S,_23994),export_file_preds(S),!.
:-export(export_file_preds/1).
export_file_preds(_29850):-current_prolog_flag(xref,true),!.
export_file_preds(FileMatch) :-  
  forall( must(filematch(FileMatch,File)), 
    ( source_context_module(NotUser)  ,
      show_call(why,NotUser\==user) , 
      forall( 
         must(mpred_source_file(M:P,File)), 
         ( functor(P,F,A) , 
           must(export_file_preds(NotUser,File,M,P,F,A)))))).
predicate_decl_module(Pred,RM) :- 
  current_predicate(_49374,RM:Pred) , 
  \+predicate_property(RM:Pred,imported_from(_49550)) , 
  must(RM\==user).
:-style_check(-singleton).
:-dynamic baseKB:(mpred_is_impl_file/1).
:-multifile baseKB:(mpred_is_impl_file/1).
:-volatile baseKB:(mpred_is_impl_file/1).
:-if(false).
:-else.
:-endif.
write_modules :- forall(baseKB:mpred_is_impl_file(F),(export_file_preds(F),list_file_preds(F))).
export_file_preds(NotUser,S,M_S8,P,F,A) :- 
  current_predicate(logicmoo_varnames:(F/A)) , 
  !.
export_file_preds(NotUser,S,system,P,F,A) :- 
  current_predicate(system:(F/A)) , 
  !.
export_file_preds(NotUser,S,user,P,F,A) :- 
  current_predicate(system:(F/A)) , 
  !.
export_file_preds(NotUser,S,M,P,F,A) :- 
  M==user , 
  ! , 
  dtrace , 
  show_call(why,export_file_preds(NotUser,S,NotUser,P,F,A)).
export_file_preds(NotUser,S,M,P,F,A) :- 
  predicate_decl_module(P,RM) , 
  RM\==M , 
  ! , 
  export_file_preds(NotUser,S,RM,P,F,A).
export_file_preds(NotUser,S,M,P,F,A) :- 
  M:export(M:(F/A)) , 
  fail.
 % export anyways
export_file_preds(NotUser,S,M,P,F,A) :- 
  M:(module_transparent F/A) , 
  fail.
export_file_preds(NotUser,S,M,P,F,A) :-  
  must(predicate_property(M:P,transparent)).
:-style_check(+singleton).
:-module_transparent export_module_preds/0.
:-export(export_module_preds/0).
export_module_preds:-current_prolog_flag(xref,true),!.
export_module_preds :- 
  source_context_module(M) , 
  source_file_property(S,module(M)) , 
  export_file_preds(S) , 
  forall(source_file_property(S,includes(F,_138070)),export_file_preds(F)).
merge_mode_and_varname(ModeAs,NameAs,ModeAs:NameAs).
:-dynamic baseKB:(mpred_is_impl_file/1).
:-multifile baseKB:(mpred_is_impl_file/1).
:-volatile baseKB:(mpred_is_impl_file/1).
target_module(P,M) :- 
  mpred_source_file(M:P,F) , 
  baseKB : mpred_is_impl_file(F) , 
  make_module_name(F,M).
autodoc_output_path(File,PlDocFile) :- 
  atom_subst(File,'/prolog','/pldox',PlDocFile01) , 
  atom_subst(PlDocFile01,'Assets','PLDoc',PlDocFile0) , 
  ( PlDocFile0\==File->PlDocFile=PlDocFile0 ; 
    ( atom_subst(PlDocFile0,'/logicmoo_base/','/logicmoo_base_docs/',PlDocFile1) , 
      ( PlDocFile1\==PlDocFile0->PlDocFile=PlDocFile1 ; 
        PlDocFile=user))) , 
  ( PlDocFile==user->true ; 
    file_directory_name(PlDocFile,Dir),make_directory_path(Dir)) , 
  !.
skip_autodoc_file_0('/mnt/sdc1/logicmoo_workspace.1/packs_sys/lps_corner/swish/lps_server_UI.pl').

%= 	 	 

%% skip_autodoc_file_0( ?ATOM1) is semidet.
%
% Skip Autodoc File  Primary Helper.
%
:-op(1200,xfy,==>>).
:-op(1200,xfy,::=).
autodoc_file(File):-with_vars_unlocked(autodoc_file_0(File)),!.

%= 	 	 

%% autodoc_file( ?File) is semidet.
%
% Autodoc File.
%
autodoc_file_0(File) :- 
  var(File) , 
  ! , 
  no_repeats(varname_cache:varname_info_file(File)) , 
  autodoc_file_0(File).
autodoc_file_0(*):-!,autodoc_file_0s.
autodoc_file_0(module(M)):-!,autodoc_module(M).
autodoc_file_0(File) :-  
  forall(must(filematch(File,E)),autodoc_file_00(E)).
autodoc_file_00(File) :- 
  skip_autodoc_file_0(File) , 
  ! , 
  autodoc_dbg(skip_autodoc_file_0(File)).

%= 	 	 

%% autodoc_file_00( ?File) is semidet.
%
% Autodoc File  Primary Helper Primary Helper.
%
autodoc_file_00(File) :- 
  autodoc_setup , 
  each_call_cleanup(tell(user_error),autodoc_file_0_0(File),told) , 
  !.
autodoc_dbg(E):-dmsg(E).

%= 	 	 

%% autodoc_dbg( ?E) is semidet.
%
% Autodoc Dbg.
%
 % with_output_to(current_output,mu:dbug1(E)).
% autodoc_dbg(E):- with_output_to(current_output,pprint_ecp_cmt(magenta,E)).
% autodoc_dbg(E):- with_output_to(current_output,dbug1(E)).
%autodoc_dbg(E):- with_output_to(user_error,dbug1(E)).
autodoc_file_0_0(File) :- 
  show_call(_7792,autodoc_output_path(File,PlDocFile)) , 
  nop(read_source_file_vars(File)) , 
  retractall(t_l:last_predicate_help_shown(_7952,_7974,_7996)) , 
  retractall(t_l:last_source_file_help_shown(File,_8082,_8104)) , 
  locally( set_prolog_flag(xref,false), 
    locally_tl( disable_px, 
      must_det_l( ( make_module_name(File,M)  ,
                    M:convert_to_dynamic(M,'$pldoc',4) , 
                    setup_call_cleanup( system : tell(PlDocFile), 
                      setup_call_cleanup( open(File,read,LineByLineStream), 
                        setup_call_cleanup( prolog_open_source(File,In), 
                          autodoc_stream(LineByLineStream,File,In), 
                          prolog_close_source(In)), 
                        copy_until_line(LineByLineStream,999999999999),close(LineByLineStream)), 
                      told))))).
autodoc_setup:-!.
autodoc_setup:-scan_for_varnames,use_listing_vars,make,autoload,make,scan_for_varnames.
autodoc_module(M) :-  
  doall( ( source_file(M:P,File)  ,
           \+predicate_property(M:P,imported_from(M8)) , 
           ignore(predicate_property(M:P,line_count(Start))) , 
           must( autodoc_stream_data( D37854_M7, 
                   M, File,Start-Start6, 
                   P,P,_Vs)))).
read_once(In,Term,Expanded,Vs,TermPos) :-  
  read_once(In,Term,Expanded,Vs,TermPos,[syntax_errors(error)]).
read_once(In,Term,Expanded,Vs,TermPos,Options) :- 
  as_stream(In,Inn) , 
  prolog_read_source_term( Inn, 
    Term, 
    Expanded, 
    [ variable_names(Vs), 
      term_position(TermPos) | 
      Options]) , 
  must_det_l( ( \+ \+autodoc_on_varnames(Term,Vs)  ,
                ignore((Expanded\==Term-> \+ \+autodoc_on_varnames(Expanded,Vs))) , 
                autodoc_on_directive(Expanded))).

%= 	 	 

%% read_once( -In, ?Term, ?Expanded, ?Vs, ?TermPos, ?Options) is semidet.
%
% Read Once.
%
as_stream(In,Inn) :- 
  atomic(In) , 
  is_stream(In) , 
  ! , 
  Inn=In.

%= 	 	 

%% as_stream( -In, -Inn) is semidet.
%
% Converted To Stream.
%
as_stream(In,Inn) :- 
  with_output_to(chars(Cs),write(In)) , 
  open_chars_stream(Cs,Inn).
guess_source_module(MHB,M,HB) :- 
  strip_module(MHB,M,HB) , 
  HB\==MHB , 
  !.
guess_source_module((MH:-B),M,(H:-B)) :- 
  strip_module(MH,M,H) , 
  H\==MH , 
  !.
guess_source_module(HB,M,HB):-prolog_load_context(module,M),!.
autodoc_on_varnames(MMHB,Vs) :-  
  ignore( catch( must(autodoc_on_varnames_0(MMHB,Vs)), 
            E, 
            autodoc_dbg((E-->MMHB)))).
autodoc_on_varnames_0(MMHB,_Vs):-ground(MMHB),!.
autodoc_on_varnames_0(MMHB,Vs) :- 
  guess_source_module(MMHB,M,HB) , 
  must((nonvar(M);source_context_module(M))) , 
  Why=cuz , 
  ignore( ( var(Why)  ,
            current_why(Why) , 
            setarg(2,Why,M) , 
            setarg(1,Why,Vs))) , 
  must(init_varname_stores(M)) , 
  ignore((var(Why),loading_file(Why))) , 
  expand_to_hb(HB,H,B) , 
  autodoc_assert(varname_cache:varname_info(H,B,Vs,Why)) , 
  must(\+ \+autodoc_on_arg_vars(M,H,B,Vs,Why)).
each_into_dollar_var(Name=Var) :-  
  ignore((var(Var),atomic(Name),Var='$VAR'(Name))).

%= 	 	 

%% each_into_dollar_var( ?Name) is semidet.
%
% Each Converted To Dollar Variable.
%
each_into_typedvar(Name=Var) :-  
  ignore( ( var(Var)  ,
            atomic(Name) , 
            Var =  
              aVar(Name,att(typehint,[Name],[])))).

%= 	 	 

%% each_into_typedvar( ?Name) is semidet.
%
% Each Converted To Typedvar.
%
get_unnamed_vars(HB,Vs,Unnamed) :- 
  term_variables(HB,Originals) , 
  term_variables(Vs,Named) , 
  list_to_ord_set(Originals,SO) , 
  list_to_ord_set(Named,SN) , 
  ord_subtract(SO,SN,Unnamed) , 
  !.

%= 	 	 

%% get_unnamed_vars( ?HB, ?Vs, ?Unnamed) is semidet.
%
% Get Unnamed Variables.
%
add_unnamed_vars(Vs,[],Vs):-!.

%= 	 	 

%% add_unnamed_vars( ?ARG1, ?ARG2, ?Vs) is semidet.
%
% Add Unnamed Variables.
%
add_unnamed_vars(Vs0,[U|Unnamed],Vs) :- 
  member(_40166=VV,Vs0) , 
  U==VV , 
  ! , 
  add_unnamed_vars(Vs0,Unnamed,Vs).
add_unnamed_vars(Vs0,[U|Unnamed],[N=U|Vs]) :- 
  name_unnamed_var(U,N) , 
  ! , 
  add_unnamed_vars(Vs0,Unnamed,Vs).
name_unnamed_var(U,N) :- 
  var(U) , 
  format(atom(N),'~w',[U]).

%= 	 	 

%% name_unnamed_var( ?U, ?N) is semidet.
%
% Name Unnamed Variable.
%
name_unnamed_var(_U,_N).
autodoc_on_arg_vars(M,H,B,Vs0,Why) :-  
  must_det_l( ( get_unnamed_vars(H+B,Vs0,Unnamed)  ,
                add_unnamed_vars(Vs0,Unnamed,Vs) , 
                copy_term(H+B+Vs,CH+CB+CVs) , 
                must_maplist(each_into_dollar_var,CVs) , 
                hb_to_clause(CH,CB,CHB) , 
                autodoc_on_info(M,CHB,CH,CB,CVs,Why) , 
                autodoc_on_vardeps(M,CHB,H,B,Vs,Why))).

%= 	 	 

%% autodoc_on_arg_vars( ?M, ?H, ?B, ?Vs0, ?Why) is semidet.
%
% Autodoc Whenever Argument Variables.
%
autodoc_on_info(_M,CHB,CH,CB,_CVs,Why) :- 
  ArgInfo=arginfo_for(CHB,Why,[]) , 
  must_det_l( ( autodoc_assert(arg_info(CH))  ,
                track_arg_info(b,&(ArgInfo,call(new_arg_info(CH,Why))),CB) , 
                track_arg_info(h,ArgInfo,CH) , 
                autodoc_assert(ArgInfo))).

%= 	 	 

%% autodoc_on_info( ?M, ?CHB, ?CH, ?CB, ?CVs, ?Why) is semidet.
%
% Autodoc Whenever Info.
%
new_arg_info(_CH,_Why,Arg):-autodoc_unused_arg(Arg),!.

%= 	 	 

%% new_arg_info( ?CH, ?Why, ?Arg) is semidet.
%
% New Argument Info.
%
 new_arg_info(_CH,_Why,Arg):-no_topvar(Arg),!.
new_arg_info(_CH,_Why,Arg):-autodoc_assert(arg_info(Arg)).
:-multifile user:(argname_hook/4).
:-dynamic user:(argname_hook/4).
user : argname_hook(F,A,N,T) :- 
  ground(v(F,A)) , 
  A>0 , 
  F\==(=) , 
  functor(P,F,A) , 
  autodoc_call(arg_info(P)) , 
  arg(N,P,'$VAR'(T)) , 
  nonvar(T).

%= 	 	 

%% argname_hook( ?F, ?A, ?N, ?T) is semidet.
%
% Argname Hook.
%
autodoc_call(Goal):-autodoc_temp:call(Goal).

%= 	 	 

%% autodoc_call( :GoalGoal) is semidet.
%
% Autodoc Call.
%
:-dynamic autodoc_temp:(arg_info/1).
autodoc_assert(ArgInfo) :- 
  autodoc_temp : assert_if_new(ArgInfo) , 
  nop(autodoc_dbg(ArgInfo)).

%= 	 	 

%% autodoc_assert( -ArgInfo) is semidet.
%
% Autodoc Assert.
%
no_topvar(Arg) :- 
  \+ (arg(_221994,Arg,E),nonvar(E),E='$VAR'(_222114)) , 
  !.

%= 	 	 

%% no_topvar( ?Arg) is semidet.
%
% No Topvar.
%
autodoc_unused_arg(H):- \+compound(H),!.

%= 	 	 

%% autodoc_unused_arg( ?H) is semidet.
%
% Autodoc Unused Argument.
%
autodoc_unused_arg(H):-compound_name_arity(H,_246704,0),!.
autodoc_unused_arg(H):-compound_name_arity(H,'$VAR',_250114),!.
autodoc_unused_arg(H):-compound_name_arity(H,aVar,_253528),!.
compares_what(H,V1,V2) :- 
  compound(H) , 
  compound_name_arguments(H,OP,[V1,V2]) , 
  atom_concat(_258108,=,OP) , 
  !.

%= 	 	 

%% compares_what( ?H, ?V1, ?V2) is semidet.
%
% Compares What.
%
track_arg_info(_17328,_17350,H):-autodoc_unused_arg(H),!.

%= 	 	 

%% track_arg_info( ?ARG1, ?ARG2, ?H) is semidet.
%
% Track Argument Info.
%
track_arg_info(Ctx,ArgInfo,H) :- 
  compares_what(H,V1,V2) , 
  ! , 
  track_arg_info(Ctx,ArgInfo,compares(V1,V2)).
track_arg_info(Ctx,ArgInfo,H) :- 
  compound_name_arguments(H,F,Args) , 
  functor(H,F,A) , 
  must(once((is_goal_oper(F,A);push_frame_if_used(H,ArgInfo)))) , 
  must_maplist(track_arg_info(F-Ctx,ArgInfo),Args).
is_goal_oper(F,_52644):-upcase_atom(F,U),downcase_atom(F,U).

%= 	 	 

%% is_goal_oper( ?F, ?ARG2) is semidet.
%
% If Is A Goal Oper.
%
push_frame_if_used(H,_70042):-no_topvar(H),!.

%= 	 	 

%% push_frame_if_used( ?H, ?ARG2) is semidet.
%
% Push Frame If Used.
%
push_frame_if_used(H,ArgInfo):-my_push_frame(H,ArgInfo).
my_push_frame(H,_90358):-compound(H),functor(H,push_frame,2),!.

%= 	 	 

%% my_push_frame( ?H, ?ARG2) is semidet.
%
% My Push Frame.
%
my_push_frame(H,ArgInfo):-push_frame(H,ArgInfo).
autodoc_on_vardeps(_M,CHB,H,B,Vs,Why) :-  
  must_det_l( ( must_maplist(each_into_typedvar,Vs)  ,
                UnusedHints=unused_frame_for(CHB,Vs,Why,[]) , 
                extract_type_hints(h,UnusedHints,H) , 
                extract_type_hints(b,UnusedHints,B) , 
                must_maplist(autodoc_interargs,Vs))).

%= 	 	 

%% autodoc_on_vardeps( ?M, ?CHB, ?H, ?B, ?Vs, ?Why) is semidet.
%
% Autodoc Whenever Vardeps.
%
autodoc_interargs(Term):- \+compound(Term),!.

%= 	 	 

%% autodoc_interargs( ?Term) is semidet.
%
% Autodoc Interargs.
%
autodoc_interargs(_155976=Term):-!,autodoc_interargs(Term).
autodoc_interargs(Term) :- 
  get_type_hints(Term,_Name,Hints) , 
  forall( ( select(Infix1,Hints,Rest)  ,
            member(Infix2,Rest) , 
            \+atom(Infix1) , 
            \+atom(Infix2)), 
    autodoc_interpreds(Infix1,Infix2)).
autodoc_interargs(_Term):-!.
autodoc_interpreds(A,B) :- 
  A@>B , 
  ! , 
  autodoc_interpreds(B,A).

%= 	 	 

%% autodoc_interpreds( ?A, ?B) is semidet.
%
% Autodoc Interpreds.
%
autodoc_interpreds(argOf(FA1,N1),argOf(FA2,N2)) :- 
  autodoc_assert(interargs(FA1,N1,FA2,N2)) , 
  !.
autodoc_interpreds(Infix1,Infix2):-autodoc_assert(interargs(Infix1,Infix2)).
extract_type_hints(_196584,_196606,H):-autodoc_unused_arg(H),!.

%= 	 	 

%% extract_type_hints( ?ARG1, ?ARG2, ?H) is semidet.
%
% Extract Type Hints.
%
extract_type_hints(Ctx,Frame,H) :- 
  extract_type_hints_for_head(Ctx,H,Frame) , 
  compound_name_arguments(H,_219206,Args) , 
  must_maplist(extract_type_hints(Ctx,Frame),Args) , 
  !.
extract_type_hints_for_head(Ctx,H,Frame) :- 
  compound_name_arity(H,F,A) , 
  extract_each_arg_type_hints(1,F,A,Ctx,H,Frame).

%= 	 	 

%% extract_type_hints_for_head( ?Ctx, ?H, ?Frame) is semidet.
%
% Extract Type Hints For Head.
%
extract_each_arg_type_hints(N,_F,A,_Ctx,_H,_Frame) :- 
  N>A , 
  !.

%= 	 	 

%% extract_each_arg_type_hints( ?N, ?F, ?A, ?Ctx, ?H, ?Frame) is semidet.
%
% Extract Each Argument Type Hints.
%
extract_each_arg_type_hints(N,F,A,Ctx,H,Frame) :- 
  arg(N,H,E) , 
  extract_one_arg_type_hints(N,F,A,Ctx,H,E,Frame) , 
  N2 is N+1 , 
  extract_each_arg_type_hints(N2,F,A,Ctx,H,Frame) , 
  !.
extract_one_arg_type_hints(N,F,A,_Ctx,_H,E,Frame) :- 
  get_type_hints(E,Name,Atts) , 
  CallInfo =  
    argOf(F/A,N) , 
  my_push_frame(CallInfo,Atts) , 
  nop(my_push_frame(u(Name,CallInfo),Frame)).

%= 	 	 

%% extract_one_arg_type_hints( ?N, ?F, ?A, ?Ctx, ?H, ?E, ?Frame) is semidet.
%
% Extract One Argument Type Hints.
%
extract_one_arg_type_hints( _N, 
  _F, _A,_Ctx,_H, 
  _E,_Frame) :-  
  !.
is_avar(Term):-compound(Term),compound_name_arity(Term,aVar,2).

%= 	 	 

%% is_avar( ?Term) is semidet.
%
% If Is A Avar.
%
get_type_hints(Term,Name,Hints) :- 
  compound(Term) , 
  Term=aVar(Name,_105742) , 
  oo_get_attr(Term,typehint,Hints).

%= 	 	 

%% get_type_hints( ?Term, ?Name, -Hints) is semidet.
%
% Get Type Hints.
%
autodoc_on_directive(Expanded):- \+compound(Expanded),!.
autodoc_on_directive((:-Expanded)):- \+compound(Expanded),!.
autodoc_on_directive((:-'$set_source_module'(M))):-'$set_source_module'(M).
autodoc_on_directive((:-op(P,XF,Atom))) :- 
  ! , 
  push_op(P,XF,Atom).
autodoc_on_directive((A,B)) :- 
  ! , 
  autodoc_on_directive(A) , 
  autodoc_on_directive(B).
autodoc_on_directive(_Expanded).
autodoc_stream(LineByLineStream,File,In) :-  
  setup_call_cleanup( push_operators([]), 
    autodoc_stream_0(LineByLineStream,File,In), 
    pop_operators).
autodoc_stream_0(LineByLineStream,File,In) :- 
  make_module_name(File,M) , 
  repeat , 
  catch( 
     ( stream_property(In,position(Pos)) , 
       quietly(read_once(In,Term,Expanded,Vs,TermPos))), 
     E, 
     ( dumpST  ,
       call( ( nop(set_stream_position(In,Pos))  ,
               autodoc_dbg(E) , 
               notrace , 
               dtrace , 
               rtrace(read_once(In,Term,Expanded,Vs,TermPos)))) , 
       fail)) , 
  stream_position_data(line_count,TermPos,Start) , 
  line_count(In,End) , 
  ( Term==end_of_file->copy_until_line(LineByLineStream,999999999999),! ; 
    ( must( autodoc_stream_data( LineByLineStream, 
              M, File,Start-End, 
              Term,Expanded,Vs)) , 
      fail)).
autodoc_file_0s :- 
  autodoc_setup , 
  ! , 
  doall( ( no_repeats(varname_cache:varname_info_file(File))  ,
           once(atom_contains(File,logicmoo)) , 
           must_det_l(autodoc_file_0(File)))).
copy_until_line(Src,_199008):-(\+is_stream(Src);at_end_of_stream(Src)),!.
copy_until_line(Src,LineNo) :- 
  repeat , 
  ( at_end_of_stream(Src)->! ; 
    ( line_count(Src,CurrentLinePos) , 
      ( CurrentLinePos>=LineNo->! ; 
        with_output_doc(echo_one_line_or_skip_autodoc(Src)),fail))).
autodoc_magic(Starter):-Starter="\n%= \t \t \n\n".
autodoc_magic(Starter):-Starter="\n% \t \t \n".
echo_one_line_or_skip_autodoc(Src):-at_end_of_stream(Src),!.
echo_one_line_or_skip_autodoc(Src) :- 
  autodoc_magic(Find) , 
  string_length(Find,L) , 
  peek_string(Src,L,Peeked) , 
  Peeked=Find , 
  ! , 
  read_line_to_codes(Src,_225856) , 
  ! , 
  repeat , 
  read_line_to_codes(Src,_226024) , 
  peek_string(Src,1,Was) , 
  Was\=="%" , 
  !.
echo_one_line_or_skip_autodoc(Src) :- 
  do_white(Src) , 
  ! , 
  echo_one_line_or_skip_autodoc(Src).
echo_one_line_or_skip_autodoc(Src) :- 
  recode_codes(Src,Recodes) , 
  doc_format('~s',[Recodes]).
do_white(In):-peek_char(In,'\n'),!,fail.

%= 	 	 

%% do_white( -In) is semidet.
%
% Do White.
%
do_white(In) :- 
  peek_char(In,Code) , 
  char_type(Code,white) , 
  get_char(In,Code) , 
  ! , 
  doc_format('~w',[Code]).
do_white(In) :- 
  peek_char(In,Code) , 
  Code=='%' , 
  read_term_line_to_codes(In,Codes) , 
  ! , 
  doc_format('~s~n',[Codes]).
:-thread_local t_l:(file_loc/1).
with_output_doc(G) :- 
  with_output_to(codes(C),G) , 
  doc_format('~s',[C]) , 
  format(user_error,'~s',[C]).

%= 	 	 

%% with_output_doc( ?G) is semidet.
%
% Using Output Document.
%
doc_format(T,S):-format(T,S).

%= 	 	 

%% doc_format( ?T, ?S) is semidet.
%
% Document Format.
%
finisher('').

%= 	 	 

%% finisher( ?ATOM1) is semidet.
%
% Finisher.
%
finisher('.').
finisher('(done).').
prolog_read_source_term_local(In,Term,Expanded,Opts,F) :- 
  \+is_stream(In) , 
  as_stream(In,Inn) , 
  ! , 
  prolog_read_source_term_local(Inn,Term,Expanded,Opts,F).

%= 	 	 

%% prolog_read_source_term_local( -In, ?Term, ?Expanded, ?Opts, ?F) is semidet.
%
% Prolog Read Source Term Local.
%
prolog_read_source_term_local(In,Term,Expanded,Opts,'') :- 
  prolog_read_source_term(In,Term,Expanded,Opts) , 
  !.
prolog_read_source_term_local(In,Term,Expanded,Opts,F) :- 
  read_stream_to_codes(In,Codes) , 
  finisher(F) , 
  format(codes(NewCodes),'~s~w',[Codes,F]) , 
  open_chars_stream(NewCodes,NewStream) , 
  catch( 
     prolog_read_source_term( NewStream, 
       Term, 
       Expanded, 
       [ syntax_errors(quiet) | 
         Opts]), _97110,fail) , 
  !.
read_term_line_to_codes(Src,Codes):-read_line_to_codes(Src,Codes).

%= 	 	 

%% read_term_line_to_codes( ?Src, ?Codes) is semidet.
%
% Read Term Line Converted To Codes.
%
recode_codes(In,[Code]) :- 
  peek_code(In,Code) , 
  code_type(Code,white) , 
  get_code(In,Code) , 
  !.

%= 	 	 

%% recode_codes( -In, ?Code) is semidet.
%
% Recode Codes.
%
recode_codes(Code,Out) :- 
  fail , 
  Opts =  
    [ subterm_positions(D146854), process_comment(false),comments(D146876), 
      quasi_quotations(D146898)] , 
  read_clause( Code, 
    Term, 
    [ singletons(Singles), 
      variable_names(Vs) | 
      Opts]) , 
  append(Vs,Singles,Vars) , 
  maplist(reinclude_vars,Vars) , 
  with_output_to(codes(Out),with_pos_write(Term,Vars,Opts)) , 
  !.
recode_codes(Code,Out) :- 
  Opts =  
    [ subterm_positions(D146854), 
      comments(D146876), 
      quasi_quotations(D146898)] , 
  prolog_read_source_term( Code, 
    Term, 
    _173650, 
    [ singletons(Singles), 
      variable_names(Vs) | 
      Opts]) , 
  append(Vs,Singles,Vars) , 
  locally( nb_setval('$variable_names',Vars), 
    ( maplist(reinclude_vars,Vars) , 
      with_output_to(codes(Out),with_pos_write(Term,Vars,Opts)))) , 
  !.
recode_codes(Src,Codes):-read_term_line_to_codes(Src,Codes).
with_pos_write(Term,Vs,Opts) :- 
  with_output_to(string(S),writeq(with_pos_write(Term,Vs,Opts))) , 
  nop(log(S)) , 
  print_tree_with_final(Term,'.\n').

%= 	 	 

%% with_pos_write( ?Term, ?Vs, ?Opts) is semidet.
%
% Using Pos Write.
%
reinclude_vars(N=V):-V='$VAR'(N).

%= 	 	 

%% reinclude_vars( ?N) is semidet.
%
% Reinclude Variables.
%
autodoc_stream_data( Src, 
  M, File,From_To, 
  (Was:-Was7),Expanded, 
  Vs) :- 
  nonvar(Was) , 
  ! , 
  autodoc_stream_data( Src, 
    M, File,From_To,Was, 
    Expanded,Vs).
autodoc_stream_data( Src, 
  M, File,From_To, 
  (Was-->Was7),Expanded, 
  Vs) :- 
  nonvar(Was) , 
  ! , 
  autodoc_stream_data( Src, 
    M, File,From_To,Was, 
    Expanded,Vs).
autodoc_stream_data( _Src, 
  _M, _File,_From_To,(:-Was), 
  _Expanded,_Vs) :- 
  nonvar(Was) , 
  !.
autodoc_stream_data( Src, 
  M, File,FromLine1-_EndingLine, 
  Term,_Expanded,_Vs) :- 
  FromLine is FromLine1-0 , 
  strip_module(Term,_MU,PI) , 
  get_functor(PI,F,A) , 
  locally_tl( file_loc(File:FromLine), 
    ( copy_until_line(Src,FromLine) , 
      autodoc_stream_pred(FromLine,File,M:(F/A)))) , 
  !.
:-dynamic t_l:(last_source_file_help_shown/3).
:-dynamic t_l:(last_predicate_help_shown/3).
autodoc_stream_pred(LineByLineStream_File4,File,M:(F/A)) :- 
  t_l : last_source_file_help_shown(File,M:(F/A),D3276_Kw) , 
  !.
autodoc_stream_pred(FromLine,File,M:(F/A)) :- 
  ! , 
  autodoc_assert( t_l : last_source_file_help_shown(File,M:(F/A),FromLine)) , 
  functor(P,F,A) , 
  with_output_doc(autodoc_pred(M,M:P)) , 
  !.
autodoc_stream_pred(FromLine,File,M:P) :- 
  ! , 
  get_functor(P,F,A) , 
  autodoc_stream_pred(FromLine,File,M:(F/A)).
autodoc_stream_pred(FromLine,File,P) :- 
  ! , 
  get_functor(P,F,A) , 
  autodoc_stream_pred(FromLine,File,_M:(F/A)).
autodoc_pred(M,M:P0) :- 
  t_l : last_predicate_help_shown(M,D3146_M2,P0) , 
  !.
autodoc_pred(M,M:P0) :- 
  once(to_comparable_name_arity(P0,F,A)) , 
  functor(P,F,A) , 
  M\==baseKB , 
  predicate_property(baseKB:P,_94576) , 
  \+predicate_property(baseKB:P,imported_from(_94686)) , 
  !.
autodoc_pred(M,M:P0) :- 
  once(to_comparable_name_arity(P0,F,A)) , 
  clause(M:'$pldoc'(F/A,_103338,S,D),true) , 
  S\==D , 
  !.
autodoc_pred(_109502,MP):-MP=_109602:end_of_file,!.
autodoc_pred(M,M:P0) :- 
  autodoc_assert(t_l:last_predicate_help_shown(M,M,P0)) , 
  must_det_l( ( once(to_comparable_name_arity(P0,F,A))  ,
                functor(NameH,F,A) , 
                NameH=..[F|NameAs] , 
                functor(ModeH,F,A) , 
                ModeH=..[F|ModeAs] , 
                functor(NameM,F,A) , 
                NameM=..[F|NameAsM] , 
                functor(ModeM,F,A) , 
                ModeM=..[F|ModeAsM] , 
                functor(NameO,F,A) , 
                NameO=..[F|NameAsO] , 
                functor(ModeO,F,A) , 
                ModeO=..[F|ModeAsO] , 
                lock_vars(NameAs) , 
                all_different_vars([_|NameAs]) , 
                attempt_head_vnames(M:NameH) , 
                unlock_vars(NameAs) , 
                attempt_head_modes(M:ModeH) , 
                functor(P,F,A) , 
                functor(DocH,F,A) , 
                DocH=..[F|DocAs] , 
                functor(DocM,F,A) , 
                DocM=..[F|DocAsM] , 
                functor(DocO,F,A) , 
                DocO=..[F|DocAsO] , 
                must_maplist(merge_mode_and_varname,ModeAs,NameAs,DocAs) , 
                must_maplist(merge_mode_and_varname,ModeAsM,NameAsM,DocAsM) , 
                must_maplist(merge_mode_and_varname,ModeAsO,NameAsO,DocAsO) , 
                all_different_vars([_|NameAsM]) , 
                all_different_vars([_|NameAsO]) , 
                fixup_doc_args(fixda,P,1,DocAs,DocAsM) , 
                fixup_doc_args(fixda,P,1,DocAsM,DocAsO) , 
                fixup_doc_args(fixda2,P,1,DocAsM,DocAsO) , 
                must_maplist(fix_doc_args_for_write,DocAsO,DocAsOW) , 
                HDocAsNew=..[F|DocAsOW] , 
                ignore(some_flocation(MN,F,A)) , 
                ignore(MN=M) , 
                prefixed_module(M,MN,HDocAsNew,PrefixedDocH) , 
                for_m_make_summary(M,PrefixedDocH,SummaryI) , 
                notes_to_better_text(autodoc_toPropercase,SummaryI,SummaryA) , 
                atom_string(SummaryA,Summary) , 
                t_l : file_loc(FileFromLine) , 
                autodoc_assert( M :  
                                  '$pldoc'(F/A,FileFromLine,Summary,Summary)) , 
                autodoc_magic(Starter) , 
                doc_format( '~N~s%% ~w is semidet.\n%\n% ~w.\n%\n', [
                  Starter, HDocAsNew,Summary]))) , 
  !.
autodoc_toPropercase(I,O) :- 
  catch(logicmoo_util_strings:toPropercase(I,O),_173630,fail) , 
  !.
autodoc_toPropercase(I,I).
ignored_assignment(A,B):-ignore(A=B).
fix_doc_args_for_write(Var:A,SF) :- 
  var(Var) , 
  format(atom(SF),' ?~w',[A]).
fix_doc_args_for_write((*):A,SF) :-  
  format(atom(SF),' :Term~w',[A]).
fix_doc_args_for_write(0:A,SF) :-  
  format(atom(SF),' :Goal~w',[A]).
fix_doc_args_for_write(I:A,SF) :- 
  integer(I) , 
  format(atom(SF),' :PRED~w~w',[I,A]).
fix_doc_args_for_write(? : A,SF) :-  
  format(atom(SF),' ?~w',[A]).
fix_doc_args_for_write((+):A,SF) :-  
  format(atom(SF),' +~w',[A]).
fix_doc_args_for_write((-):A,SF) :-  
  format(atom(SF),' -~w',[A]).
fix_doc_args_for_write([_216548|_216570]:A,SF) :-  
  format(atom(SF),' ?list:~w',[A]).
fix_doc_args_for_write(A2:A,SF) :- 
  ! , 
  fix_doc_args_for_write(? : A,SF).
fix_doc_args_for_write(A,A).
attempt_head_vnames(NameH1:NameH) :- 
  attempt_head_varnames_0(NameH) , 
  get_random_headvars(NameH) , 
  !.
attempt_head_vnames(_19728:NameH):-get_random_headvars(NameH),!.
attempt_head_vnames(_23022:NameH):-attempt_head_varnames_0(NameH).
attempt_head_varnames_0(NameH):- \+compound(NameH),!.
attempt_head_varnames_0(NameH) :- 
  try_get_head_vars(NameH) , 
  ground(NameH) , 
  \+( ( arg(NameH3,NameH,'$VAR'(Named))  ,
        atom(Named) , 
        upcase_atom(Named,UNamed) , 
        atom_contains(UNamed,'VAR'))) , 
  !.
attempt_head_varnames_0(NameH):-try_get_head_vars(NameH),ground(NameH),!.
attempt_head_varnames_0(NameH):-get_clause_vars(NameH),!.
attempt_head_modes(M:ModeH) :- 
  clause(M:'$mode'(ModeH,_Det),true) , 
  !.
attempt_head_modes(M:ModeH) :- 
  predicate_property(M:ModeH,(meta_predicate ModeH)) , 
  !.
attempt_head_modes(ModeH1:ModeH) :- 
  predicate_property(_1488:ModeH,(meta_predicate ModeH)) , 
  !.
attempt_head_modes(M:ModeH) :- 
  predicate_property(M:ModeH,number_of_clauses(Nth)) , 
  attempt_head_modes_0(Nth,Nth,M:ModeH) , 
  !.
attempt_head_modes(ModeH3:ModeH) :- 
  predicate_property(M:ModeH,number_of_clauses(Nth)) , 
  attempt_head_modes_0(Nth,Nth,M:ModeH) , 
  !.
attempt_head_modes(NotFound):-autodoc_dbg(attempt_head_modes(NotFound)),!.
attempt_head_modes_0(0,_26332,_26334).

%= 	 	 

%% attempt_head_modes_0( ?ARG1, ?ARG2, ?ARG3) is semidet.
%
% Attempt Head Test Modes  Primary Helper.
%
attempt_head_modes_0(1,Nth,M:ModeH) :- 
  ! , 
  clause(M:ModeH,_53240) , 
  !.
attempt_head_modes_0(Max,1,M:ModeH) :- 
  nth_clause(M:ModeH,Max,Ref) , 
  ! , 
  clause(M:ModeH,_62300,Ref) , 
  !.
attempt_head_modes_0(Max,Nth,M:ModeH) :- 
  nth_clause(M:ModeH,Nth,Ref) , 
  ( great_clause(M:ModeH,Ref) ->  
      true ; 
    ( Nth0 is Nth-1 , 
      attempt_head_modes_0(Max,Nth0,M:ModeH))) , 
  !.
attempt_head_modes_0(Attempt_head_modes_0,Nth_Kw,M:ModeH) :- 
  ! , 
  clause(M:ModeH,_81116) , 
  !.
great_clause(M:ModeH,Ref) :- 
  term_variables(ModeH,Vs1) , 
  clause(M:ModeH,_90222,Ref) , 
  term_variables(ModeH,Vs2) , 
  \+ground(Vs1) , 
  Vs1\=Vs2 , 
  !.
great_clause(M:ModeH,Ref) :- 
  term_variables(ModeH,Vs1) , 
  clause(M:ModeH,_98616,Ref) , 
  term_variables(ModeH,Vs2) , 
  Vs1\=Vs2.
fixup_doc_args(_103766,_103788,_103810,[],[]) :-  
  !.
fixup_doc_args( Pred, 
  P, N,[Doc|As], 
  [ODoc|OAs]) :- 
  must(ignore(call(Pred,P,N,Doc,ODoc))) , 
  ! , 
  N2 is N+1 , 
  must(fixup_doc_args(Pred,P,N2,As,OAs)).
:-style_check(-singleton).
fixda(P,N,M:M5,D121426_Kw) :- 
  fail , 
  sanity(M\==system) , 
  fail.
fixda(P,N,M:Name,MO:NameO) :- 
  compound(M) , 
  functor(M,_12060,A) , 
  arg(A,M,NM) , 
  fixda(P,N,NM:Name,MO:NameO) , 
  !.
fixda(P,N,M:NameV,MO:NameO) :- 
  compound(NameV) , 
  arg(1,NameV,Name) , 
  fixda(P,N,M:Name,MO:NameO) , 
  !.
fixda(P,N,M:NameV,MO:NameO) :- 
  atom(NameV) , 
  atom_concat('_',Name,NameV) , 
  fixda(P,N,M:Name,MO:NameO) , 
  !.
fixda(P,N,M:Name,M:Name) :- 
  ground(M:Name) , 
  !.
fixda(P,N,M:Name,M:Name) :- 
  var(M) , 
  nonvar(Name) , 
  name_to_mode(P,N,Name,M) , 
  !.
fixda(P,N,M:Name,M:Name) :- 
  nonvar(M) , 
  var(Name) , 
  once( ( mode_to_name(P,N,M,MName)  ,
          atom_concat(MName,N,VarName) , 
          must(Name='$VAR'(VarName)))) , 
  !.
fixda(P,N,M:Name,M:Name) :-  
  !.
fixda(_P,_N,MName,MName):-!.
fixda2(P,N,Mode:Name,ModeOO:NameOO) :-  
  ignore( ( atom_concat('ARG',N,NameV)  ,
            '$VAR'(NameV)=NameO , 
            fixda(P,N,Mode:NameO,ModeOO:NameOO))).
mode_to_name(P,N,Mode,Name) :- 
  nonvar(Mode) , 
  nonvar(Name) , 
  !.
mode_to_name(P,N,Mode,Name) :- 
  var(Name) , 
  var(Mode) , 
  !.
mode_to_name(P,N,Mode,Name) :- 
  var(Mode) , 
  nonvar(Name) , 
  ! , 
  name_to_mode(P,N,Name,Mode).
mode_to_name(P,N,Mode,Name) :- 
  mode_to_name0(Mode,Name) , 
  !.
mode_to_name(P,N,Mode,Name) :- 
  nonvar(Mode) , 
  value_to_name(P,N,Mode,Name) , 
  !.
value_to_name(P,N,Comp,'VAR'):-var(Comp),!.
value_to_name(P,N,Comp,Comp) :- 
  atom(Comp) , 
  atom_length(Comp,L) , 
  L>1 , 
  \+bad_varnamez(Comp) , 
  !.
value_to_name(P,N,Comp,NAME) :- 
  text_to_string_safe(Comp,Str) , 
  string_to_atom(Str,Atom) , 
  atom_length(Atom,L) , 
  L>1 , 
  \+bad_varnamez(Atom) , 
  NAME=Atom.
value_to_name(P,N,Comp,'LIST') :- 
  is_list(Comp) , 
  \+ \+Comp=[_125902|_125924] , 
  !.
value_to_name(P,N,Comp,'ATOM'):-atom(Comp),!.
value_to_name(P,N,Comp,'STRING'):-string(Comp),!.
value_to_name(P,N,Comp,'TERM'):-compound(Comp).
mode_to_name0(0,'GOAL').
mode_to_name0(*,'QUERY').
mode_to_name0(:,'CALL').
mode_to_name0(+,'OUT').
mode_to_name0(?,'UPARAM').
mode_to_name0(-,'IN').
mode_to_name0(I,Name):-number(I),atom_concat('PRED',I,Name).
name_to_mode(P,N,Name,Mode) :- 
  var(Name) , 
  ! , 
  mode_to_name(P,N,Mode,Name).
name_to_mode(P,N,'$VAR'(Name),Mode) :- 
  ! , 
  name_to_mode(P,N,Name,Mode) , 
  !.
name_to_mode(P,N,Name,_Mode):- \+atom(Name),!.
name_to_mode(P,N,Name,Mode) :- 
  between(1,9,Mode) , 
  mode_to_name0(Mode,Part) , 
  atom_contains(Name,Part).
name_to_mode(P,N,Name,Mode) :- 
  mode_to_name0(Mode,Part) , 
  atom_contains(Name,Part).
name_to_mode(P,N,Name,-):-atom_contains(Name,'OUT').
name_to_mode(P,N,Name,*):-atom_contains(Name,'PRED').
name_to_mode(P,N,Name,:):-atom_contains(Name,'CALL').
name_to_mode(P,N,Name,0):-atom_contains(Name,'GOAL').
name_to_mode(P,N,Name,-):-atom_contains(Name,'RESU').
name_to_mode(P,N,'I',+).
name_to_mode(P,N,'O',-).
name_to_mode(P,N,Name,?):-atom_contains(Name,'L').
name_to_mode(P,N,Name,?):-atom_contains(Name,'T').
name_to_mode(P,N,Name,+):-atom_contains(Name,'OP').
name_to_mode(P,N,Name,+):-atom_contains(Name,'IN').
name_to_mode(P,N,Name,+):-atom_concat('_',_225848,Name).
name_to_mode(P,N,Name,+):-atom_concat(_229416,'O',Name).
name_to_mode(P,N,Name,Mode) :- 
  atom(Name) , 
  upcase_atom(Name,UName) , 
  Name\==UName , 
  ! , 
  name_to_mode(P,N,UName,Mode).
name_to_mode(P,N,_Name,?):-!.
:-style_check(+singleton).
prefixed_module(_M,MN,P,MN:P) :- 
  predicate_property('$attvar':P,number_of_clauses(_247360)) , 
  \+predicate_property('$attvar':P,imported_from(_247506)) , 
  !.
prefixed_module(_M,MN,P,MN:P) :- 
  predicate_property(system:P,number_of_clauses(_254454)) , 
  \+predicate_property(system:P,imported_from(_254600)) , 
  !.
prefixed_module(M,M,DocH,DocH):-!.
prefixed_module(_M,MN,DocH,MN:DocH).
system_pred(M2:P) :- 
  predicate_property(_7366:P,imported_from(system)) , 
  current_predicate(_7452,M2:P) , 
  \+predicate_property(M2:P,imported_from(_7592)).
notes_to_better_text(TextM,Text) :- 
  flatten([TextM],TextT) , 
  must_maplist(termw_to_atom,TextT,AtomsM) , 
  atomic_list_concat(AtomsM,' ',Text) , 
  !.
notes_to_better_text(Pred,TextM,Text) :- 
  flatten([TextM],TextT) , 
  must_maplist(termw_to_atom,TextT,AtomsM) , 
  must_maplist(Pred,AtomsM,AtomsM2) , 
  atomic_list_concat(AtomsM2,' ',Text) , 
  !.
termw_to_atom(T,A):-atom(T),!,A=T.
termw_to_atom(T,A) :-  
  format(atom(A),'~w',[T]).
make_summary0(Args,F,Text) :-  
  must_det_l( make_l_summary(Args,F,TextM),notes_to_better_text(TextM,Text)).
for_m_make_summary(For,M:P,[TextOO]) :- 
  must(atom(M)) , 
  must(functor(P,F,A)) , 
  format( atom(_Prefix), 
    'Hook to [~w] for module ~w.\n%', 
    [ M:(F/A), 
      For]) , 
  must(for_m_make_summary(For,P,TextOO)).
for_m_make_summary(M_P3,P,TextOO) :- 
  compound(P) , 
  compound_name_arguments(P,F,_54058) , 
  make_summary(P,F,TextOO).
for_m_make_summary(_60072,F,TextOO):-make_summary(F,F,TextOO).
make_summary(Args,F,TextOO) :- 
  must_det_l( ( make_summary0(Args,F,Text)  ,
                make_summary0(Args,Text,TextO) , 
                make_summary0(Args,TextO,TextOO))) , 
  !.
make_l_summary(A,I,O) :- 
  must(loop_check(make_l_summary_lc(A,I,O),O=I)) , 
  !.
make_l_summary_lc(_Args,[],[]).
make_l_summary_lc(Args,H,[HL,'Primary Helper']) :- 
  atom(H) , 
  atom_concat(L,'0',H) , 
  make_l_summary(Args,L,HL) , 
  !.
make_l_summary_lc(Args,H,[HL,'Secondary Helper']) :- 
  atom(H) , 
  atom_concat(L,'1',H) , 
  make_l_summary(Args,L,HL) , 
  !.
make_l_summary_lc(Args,H,[HL,'Trace']) :- 
  atom(H) , 
  atom_concat(L,dtrace,H) , 
  make_l_summary(Args,L,HL) , 
  !.
make_l_summary_lc(Args,H,[HL,'Types']) :- 
  atom(H) , 
  atom_concat(L,types,H) , 
  make_l_summary(Args,L,HL) , 
  !.
make_l_summary_lc(Args,H,[HL,'(isa/2)']) :- 
  atom(H) , 
  atom_concat(L,isa,H) , 
  make_l_summary(Args,L,HL) , 
  !.
make_l_summary_lc(Args,H,[HL,'Extended Helper']) :- 
  atom(H) , 
  atom_concat(L,'2',H) , 
  make_l_summary(Args,L,HL) , 
  !.
make_l_summary_lc(Args,H,HL) :- 
  atom(H) , 
  atom_chars(H,Chars) , 
  append(Left,[N],Chars) , 
  char_type(N,digit) , 
  atom_number(N,Num) , 
  atom_chars(H,Left) , 
  make_l_summary(Args,[Left,Num],HL) , 
  !.
make_l_summary_lc(Args,[H1,H2|T],OUT) :- 
  append(Left,[A],[H1,H2|T]) , 
  summary_ending(A,H) , 
  flatten_text(Left,[H],AGAIN) , 
  make_l_summary(Args,AGAIN,OUT) , 
  !.
make_l_summary_lc(Args,name(N),E) :- 
  ! , 
  arg(N,Args,_141292:E);arg(N,Args,E) , 
  !.
make_l_summary_lc(Args,AGAIN,OUT) :- 
  summary_start(Left,H) , 
  flatten([Left],LLeft) , 
  append(LLeft,Rest,AGAIN) , 
  ! , 
  flatten_text(H,Rest,New) , 
  make_l_summary(Args,New,OUT) , 
  !.
make_l_summary_lc(Args,[H|T],WO) :- 
  ! , 
  must_det_l( ( make_l_summary(Args,H,HL)  ,
                make_l_summary(Args,T,TL) , 
                flatten_text(HL,TL,WO))).
make_l_summary_lc(Args,F,Text) :- 
  atom(F) , 
  atomic_list_concat(WL,'_',F) , 
  length(WL,LL) , 
  LL>1 , 
  make_l_summary(Args,WL,Text) , 
  !.
make_l_summary_lc(Args,F,Text) :- 
  atom(F) , 
  atomic_list_concat(WL,' ',F) , 
  length(WL,LL) , 
  LL>1 , 
  make_l_summary(Args,WL,Text) , 
  !.
make_l_summary_lc(Args,H,HL) :- 
  atom_chars(H,Chars) , 
  append(Left,[L,U|MORE],Chars) , 
  char_type(L,lower) , 
  char_type(U,upper) , 
  append(Left,[L],LL) , 
  atom_chars(LS,LL) , 
  downcase_atom(U,UL) , 
  atom_chars(RS,[UL|MORE]) , 
  make_l_summary(Args,[LS,RS],HL) , 
  !.
make_l_summary_lc(_Args,H,OUT) :- 
  longer_sumry(H,Sum) , 
  flatten([Sum],OUT) , 
  !.
make_l_summary_lc(_Args,H,[A]) :-  
  termw_to_atom(H,A).
summary_start([on,x],['If there is an exception in',name(1),then]).
summary_start([on],'Whenever').
summary_start([at],'When').
summary_ending(A,H) :- 
  atom(A) , 
  atom_number(A,N) , 
  ! , 
  summary_ending(N,H).
summary_ending(i,'For Internal Interface').
summary_ending(u,'For User Code').
summary_ending(t,'True Stucture').
summary_ending(0,'Primary Helper').
summary_ending(f,'False').
summary_ending(1,'Secondary Helper').
summary_ending(2,'Extended Helper').
summary_ending(E,H) :- 
  number(E) , 
  atomic_list_concat(['Helper number ',E,'.'],'',H).
flatten_text(L,R,O) :-  
  must((sanity(var(O)),flatten([L,R],O))).
longer_sumry('HIDE','Presently Unused').
longer_sumry(ain,'Assert If New').
longer_sumry(arg,'Argument').
longer_sumry(as,'Converted To').
longer_sumry(ask,'Complete Inference').
longer_sumry(attvar,'Attribute Variable').
longer_sumry(av,'Attributed vars').
longer_sumry(b,'Backtackable').
longer_sumry(bb,'Blackboard').
longer_sumry(bc,'Backchaining').
longer_sumry(box,'Datalog').
longer_sumry(boxlog,'Datalog').
longer_sumry(bugger,'LogicMoo Debugger').
longer_sumry(c,'Class').
longer_sumry(chk,'Checking').
longer_sumry(cl,'Clause').
longer_sumry(clif,'IEEE Standard Common Logic Interchange Format Version').
longer_sumry(clr,'Remove/Erase').
longer_sumry(cmt,'Comment').
longer_sumry(cnf,'Conjunctive Normal Form').
longer_sumry(ctx,'Context').
longer_sumry(d,'(Debug)').
longer_sumry(db,'Database').
longer_sumry(dcall,'Dirrectly Call').
longer_sumry(decl,'Declare').
longer_sumry(del,'Remove/Erase').
longer_sumry(det,'Deterministic').
longer_sumry(dlog,'Datalog').
longer_sumry(dnf,'Disjunctive Normal Form').
longer_sumry(doc,'Document').
longer_sumry(dom,'Domain').
longer_sumry(eq,'Using (==/2) (or =@=/2) )').
longer_sumry(f,'Functor').
longer_sumry(fa,'Functor-Arity').
longer_sumry(fc,'Forward Chaining').
longer_sumry(fmt,'Format').
longer_sumry(fn,'Function').
longer_sumry(from,'Converted From').
longer_sumry(ft,'Format Type').
longer_sumry(fwd,'Forward Repropigated').
longer_sumry(g,'Globally').
longer_sumry(h,'Head').
longer_sumry(hb,'Head+Body').
longer_sumry(i,'Instance').
longer_sumry(ilc,'Inside Of Loop Checking').
longer_sumry(impl,'Implimentation').
longer_sumry(into,'Converted To').
longer_sumry(io,'Input/Output').
longer_sumry(is,'If Is A').
longer_sumry(just,'Justification').
longer_sumry(kb,'Knowledge Base').
longer_sumry(kbp,'Knowledge Base P-').
longer_sumry(kif,'Knowledge Interchange Format').
longer_sumry(l,'(List version)').
longer_sumry(lang,'Language').
longer_sumry(lbl,'Labeling (Residuals)').
longer_sumry(lc,'not loop checked').
longer_sumry(lhs,'Left-Hand-Side').
longer_sumry(lit,'Literal').
longer_sumry(m,'Module').
longer_sumry(mfa,'Module-Functor-Arity').
longer_sumry(mfa,m_fa).
longer_sumry(minfo,'Metainformation').
longer_sumry(mode,'p Mode').
longer_sumry(mp,m_goal).
longer_sumry(mk,'Make').
longer_sumry(mpi,m_pi).
longer_sumry(mpred,'Managed Predicate').
longer_sumry(mt,'User Microtheory').
longer_sumry(mu,'Module Unit').
longer_sumry(mud,'Application').
longer_sumry(must,'Must Be Successfull').
longer_sumry(naf,'Negation-By-Faliure').
longer_sumry(nb,'Non Backtackable').
longer_sumry(neg,'Negated').
longer_sumry(neq,'Negated Equality').
longer_sumry(nesc,'Necesity').
longer_sumry(nf,'Normal Form').
longer_sumry(nnf,'Negated Normal Form').
longer_sumry(non,'Not').
longer_sumry(nots,'Negations').
longer_sumry(o,'Output').
longer_sumry(op,'Oper.').
longer_sumry(p,'Test').
longer_sumry(neg,'Negative').
longer_sumry(npc,'Automatic Character').
longer_sumry(act,'Single Doer Action').
longer_sumry(prep,'Proposition').
longer_sumry(pfc,'Prolog Forward Chaining').
longer_sumry(pi,'Predicate Indicator').
longer_sumry(poss,'Possibility').
longer_sumry(pp,'Pretty Print').
longer_sumry(pred,'Predicate').
longer_sumry(pt,'Predicate Type').
longer_sumry(quick,'Incomplete, But Fast, Version').
longer_sumry(rem,'Remove/Erase').
longer_sumry(rhs,'Right-Hand-Side').
longer_sumry(safe,'Safely Paying Attention To Corner Cases').
longer_sumry(sanity,'Optional Sanity Checking').
longer_sumry(sent,'Sentence').
longer_sumry(sexpr,'S-Expression').
longer_sumry(sk,'Skolem').
longer_sumry(st,'Stacktrace').
longer_sumry(store,'Storage').
longer_sumry(t,'True Structure').
longer_sumry(tell,'Canonicalize And Store').
longer_sumry(tf,'True/False').
longer_sumry(tl,'Thread Local').
longer_sumry(tms,'Truth Maintainence/WFF').
longer_sumry(to,'Converted To').
longer_sumry(tt,'Collection Type').
longer_sumry(umt,'User Microtheory').
longer_sumry(var,'Variable').
longer_sumry(verbose,'While Being Descriptive').
longer_sumry(wff,'Well-Formed Formula').
longer_sumry(wfs,'Well-Founded Semantics Version').
longer_sumry(why,'Generation Of Proof').
longer_sumry(with,'Using').
longer_sumry(xcall,'Extended Call').
longer_sumry(S,W) :- 
  atom(S) , 
  atom_concat(S0,msg,S) , 
  longer_sumry(S0,W0) , 
  atom_concat(W0,'Message',W).
longer_sumry(S,W) :- 
  atom(S) , 
  atom_concat(S0,s,S) , 
  longer_sumry(S0,W0) , 
  atom_concat(W0,s,W).
:-export(mpred_show_doc/1).
mpred_show_doc(What) :- 
  findall(Infos,mpred_show_doc(What,Infos),LInfos) , 
  LInfos\=[] , 
  flatten(LInfos,Infos) , 
  forall(member(E,Infos),format('~N~w~n',[E])).
mpred_show_doc(What) :- 
  match_predicates(What,Preds) , 
  Preds\==[] , 
  Preds\==[What] , 
  forall( 
     member(M:(F/A),Preds), 
     mpred_show_doc(M:(F/A))).
mpred_show_doc(M:(F/A),['$mode'(PI,Det)]) :- 
  functor(PI,F,A) , 
  clause(M:'$mode'(PI,Det),true).
mpred_show_doc(M:(F/A),[Info,Info2]) :-  
  clause(M:'$pldoc'(F/A,_FL,Info,Info2),true).
mpred_show_doc(Id,[Info,Info2]) :-  
  clause(Action_Pldoc,'$pldoc'(Id,_FL,Info,Info2),true).
mpred_show_doc(M,[Title,Info,Info2]) :-  
  pldoc_process : doc_comment(M:module(Title),_FileLines,Info,Info2).
mpred_type_module(A):- \+atom(A),!,fail.
:-dynamic mpred_prolog_only_module/1.
mpred_prolog_only_module(M) :- 
  var(M) , 
  ! , 
  current_module(M) , 
  mpred_prolog_only_module(M).
mpred_prolog_only_module(user):-!,fail.
mpred_prolog_only_module(mpred_type_wff).
mpred_prolog_only_module(logicmoo_varnames).
mpred_prolog_only_module(common_logic_compiler).
mpred_prolog_only_module(common_logic_snark).
mpred_prolog_only_module(common_logic_sexpr).
mpred_prolog_only_module(logicmoo_utils).
mpred_prolog_only_module(t_l).
mpred_prolog_only_module(tlbugger).
mpred_prolog_only_module(lmcache).
mpred_prolog_only_module(baseKB).
mpred_prolog_only_module(baseKB).
mpred_prolog_only_module(M):-atom_concat(mpred_,_129268,M).
mpred_prolog_only_module(M):-atom_concat(logicmoo_util,_132438,M).
mpred_prolog_only_module(M):-atom_concat(common_logic_,_135612,M).
autodoc_test:-make,notrace,cls,autodoc_file('Assets/Ontology/knowledge_representation.prolog'),!.
:-fixup_exports.
end_of_file.
